/* Initialize the main structOntology page */

$(document).ready(function()
{

  // Make sure indexOf works in all browsers (specifically for IE)
  if(!Array.indexOf)
  {
    Array.prototype.indexOf = function(obj)
    {
      for(var i = 0; i < this.length; i++)
      {
        if(this[i] === obj)
        {
          return i;
        }
      }
      return -1;
    }
  }

  Object.size = function(obj)
  {
    var size = 0, key;

    for(key in obj)
    {
      if(obj.hasOwnProperty(key))
      {
        size++;
      }
    }
    return size;
  };
});

var resultset;

/* List all ontologies once the main, ontologies listing, page is loaded */
function readyListOntologies()
{
  // Run the ajax loading bar image
  $('#ontologiesListContainer').append('<div class="loadingBar"><img src="' + structOntologyModuleFullPath
    + '/imgs/ajax-loading-bar.gif" width="220" height="19" /></div>');

  $.ajax({
            type: "POST",
            url: structwsfBaseURL.replace(/\/+$/,"") + "/ontology/read/",
            data: "function=getLoadedOntologies&parameters=" + escape("mode=descriptions"),
            dataType: "json",
            success: function(msg)
            {

              // Remove the loading image
              $('#ontologiesListContainer').empty();

              // Process the resultset
              resultset = new Resultset(msg);

              for(var i = 0; i < resultset.subjects.length; i++)
              {
                var ontologyModified =
                  resultset.subjects[i].getPredicateValues("http://purl.org/ontology/wsf#ontologyModified");

                if(ontologyModified.length > 0)
                {
                  if(ontologyModified[0].toUpperCase() == "TRUE")
                  {
                    ontologyModified = true;
                  }
                  else
                  {
                    ontologyModified = false;
                  }
                }
                else
                {
                  ontologyModified = false;
                }

                if(i % 2 == 0)
                {
                  $("#ontologiesListContainer").append(
                    "<div class=\"list-even\"><input type=\"radio\" class=\"radioButton\" name=\"ontologiesListRadio\" id=\"radio_"
                    + i + "\" />" + resultset.subjects[i].getPrefLabel()[0]
                      + (ontologyModified ? " <em><strong>(modified; not saved)</strong></em>" : "") + "</div>");
                }
                else
                {
                  $("#ontologiesListContainer").append(
                    "<div class=\"list-odd\"><input type=\"radio\" class=\"radioButton\" name=\"ontologiesListRadio\" id=\"radio_"
                    + i + "\" />" + resultset.subjects[i].getPrefLabel()[0]
                      + (ontologyModified ? " <em><strong>(modified; not saved)</strong></em>" : "") + "</div>");
                }

                // Check the first radio button
                if(i == 0)
                {
                  $("#radio_0").attr("checked", "checked");
                  $("#deleteButtonInputUri").val(resultset.subjects[0].uri);
                  $("#saveButtonInputUri").val(resultset.subjects[0].uri);
                  $("#removeButtonInputUri").val(resultset.subjects[0].uri);
                  $("#viewButtonIntputDataset").val(resultset.subjects[0].uri);
                  $("#exportButtonIntputDataset").val(resultset.subjects[0].uri);
                }
              }

              // Initialize all the selection radio button
              $('input[name=ontologiesListRadio]:radio').change(function()
              {

                // Get the resultset key of the dataset selected
                var key = $(this).attr("id").substr(6);

// Change all the places where the URI of the selected ontology have to be changed (action buttons, etc).

// Update the delete button's form
                $("#deleteButtonInputUri").val(resultset.subjects[key].uri);
                $("#saveButtonInputUri").val(resultset.subjects[key].uri);
                $("#removeButtonInputUri").val(resultset.subjects[key].uri);
                $("#viewButtonIntputDataset").val(resultset.subjects[key].uri);
                $("#exportButtonIntputDataset").val(resultset.subjects[key].uri);
              });
            },
            error: function(jqXHR, textStatus, error)
            {
              displayError(textStatus + " :: " + jqXHR.responseText, "ontologiesListContainer");
            }
          });
}

/* Display errors in the errors container */
function displayError(errorMsg, errorContainerID)
{
  $("#" + errorContainerID).empty();
  $("#" + errorContainerID).append('<div class="errorBox">' + errorMsg + '</div>');
}

/* Show/hide the import control to import new ontologies */
function toggleImportInput()
{
  if($("#importBox").is(':hidden'))
  {
    $("#importBox").show();
  }
  else
  {
    $("#importBox").hide();
  }
}

/* Displays the controls to create a new ontology (like the title and description inputs etc.) */
function createNew()
{
  $('#ontologiesListContainer').fadeOut('slow', function()
  {
    $('.actionViewButton').attr("disabled", "disabled");
    $('.actionExportButton').attr("disabled", "disabled");
    $('.actionDeleteButton').attr("disabled", "disabled");
    $('.actionImportButton').attr("disabled", "disabled");
    $('.actionCacheButton').attr("disabled", "disabled");
    $('.actionReloadButton').attr("disabled", "disabled");

    $('#ontologyEditContainer').fadeIn('slow', function()
    {
      $('#ontologyEditContainer').append(
        '<form method="POST">\
           <table id="ontologyDescriptionTable">\
             <tr>\
               <td>Ontology Name:</td>\
               <td class="ontologyDescriptionTd">\
                 <input type="text" id="ontologyName" name="ontologyName" class="ontologyDescriptionInput" />\
               </td>\
             </tr>\
             <tr>\
               <td>Ontology Description:</td>\
               <td class="ontologyDescriptionTd">\
                 <input type="text" name="ontologyDescription" id="ontologyDescription" class="ontologyDescriptionInput" />\
               </td>\
             </tr>\
             <tr>\
               <td>Ontology URI:</td>\
               <td class="ontologyDescriptionTd">\
                 <input type="text" id="ontologyUri" class="ontologyUriInput" name="ontologyUri" />\
               </td>\
             </tr>\
             <tr>\
               <td colspan="2">\
                 <br />\
                 <input type="submit" id="saveNewOntologyButton" value="Create New Ontology" />\
               </td>\
             </tr>\
           </table>\
           <input type="hidden" name="createNewOntology" />\
        </form>');
    })
  });
}