var classTreeNodeBinder = [];
var ontology = "";
var network = "";
var reloadTree = false;
var extendedToAllOntologies = true;
var importedFromExternalOntology = [];

// The resultset of the entity currently being created/modified
var currentEntityResultset;

var removedSuperEntityOf = [];

var loadedOntologiesNames = [];
var existingTemplates = [];

var propertiesTreeCreated = false;

var currentView = "classes";

var lastSelectedClassNode = "httpwwww3org200207owlThing";
var lastSelectedPropertyNode = "httpwwww3org200207owlTopProperty";

var searchAc;

var initiallyOpenedNodeIdReference = "";

/** Prepate the page when it is loaded */
function readyView(dataset, netwk, classUri, propertyUri)
{
  $("#classesTree").data("classUri", classUri);
  $("#classesTree").data("propertyUri", propertyUri);

  searchAc = $('#searchBox').autocomplete({
            serviceUrl: netwk.replace(/\/+$/,"") + "/search/",
            minChars: 3,
            //delimiter: /(,|;)\s*/, // regex or character
            maxHeight: 400,
            width: 300,
            iconID: "searchButtonImage",
            zIndex: 9999,
            onSelect: function(value, data)
            {
              $("#searchBox").data("uri", data);

              switch(currentView)
              {
                case "classes":
                  $("#classesTree").jstree("search", value.substring(0, value.search("&nbsp;&nbsp;&nbsp;")));
                  break;

                case "properties":
                  $("#propertiesTree").jstree("search", value.substring(0, value.search("&nbsp;&nbsp;&nbsp;")));
                  break;
              }
            },
            deferRequestBy: 0, //miliseconds
            params: {
                      datasets: dataset,
                      attributes: "http://purl.org/ontology/iron#prefLabel",
                      page: 0,
                      items: 20,
                      include_aggregates: "false",
                      types: "http://www.w3.org/2002/07/owl#Class"
                    },
            noCache: false, //default is false, set to true to disable caching
          });

  searchAc.enable();

  ontology = dataset;

  network = netwk;

  var uri = "http://www.w3.org/2002/07/owl#Thing";

  classTreeNodeBinder[uri.replace(/[^a-zA-Z0-9]+/g, '')] = uri;
  
  initiallyOpenedNodeIdReference = uri.replace(/[^a-zA-Z0-9]+/g, '');
  
  var     jstreeStructure = {
      core: {
                initially_open: [uri.replace(/[^a-zA-Z0-9]+/g, '')],
                strings: {
                          loading: "Loading ...",
                          new_node: "New class"
                        },
              },
      "json_data": {
                "data": [
                  {
                            "data": "Thing",
                            "attr": {
                                      id: uri.replace(/[^a-zA-Z0-9]+/g, '')
                                    },
                            "state": "closed"
                          }
                ],
                "ajax": {               
                          type: "POST",
                          url: network.replace(/\/+$/,"") + "/ontology/read/",
                          dataType: "json",
                          "data": function(n)
                          {
                            // Here we take the node's ID to compose the query to send to structWSF
                            return("function=getSubClasses&reasoner="+useReasoner+"&ontology=" + escape(dataset) + "&parameters="
                              + escape("mode=hierarchy") + ";" + escape("uri=" + classTreeNodeBinder[n[0].id])
                              + ";" + escape("direct=1"));
                          //id : n.attr ? n.attr("id") : 0
                          },
                          "success": function(data)
                          {

                            $('#messagesContainer').fadeOut("slow", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            // Here we read the resultset, and compose the JSON object to feed to jsTree
                            var resultset = new Resultset(data);

                            var nodes = [];

                            for(var i = 0; i < resultset.subjects.length; i++)
                            {
                              classTreeNodeBinder[resultset.subjects[i].uri.replace(/[^a-zA-Z0-9]+/g,
                                '')] = resultset.subjects[i].uri;

                              var nodeType = "default";

                              switch(resultset.subjects[i].uri.replace(/[^a-zA-Z0-9]+/g, ''))
                              {
                                case "httpwwww3org200207owlThing":
                                case "httpwwww3org200207owlNothing":
                                case "httpwwww3org200207owlDatatypeProperty":
                                case "httpwwww3org200207owlClass":
                                case "httpwwww3org200207owlObjectProperty":
                                case "httpwwww3org200207owlAnnotationProperty":
                                  nodeType = "internalClasses";
                                  break;
                              }

                              // Check if it is a super class of another class. If not, then it is a leaf
                              // node in the tree control.
                              if(resultset.subjects[i].getPredicateValues(
                                "http://purl.org/ontology/sco#hasSubClasses").length <= 0)
                              {
                                nodes.push({
                                          data: resultset.subjects[i].getPrefLabel()[0],
                                          attr: {
                                                    id: resultset.subjects[i].uri.replace(/[^a-zA-Z0-9]+/g, ''),
                                                    title: resultset.subjects[i].uri,
                                                    rel: nodeType
                                                  },
                                        });
                              }
                              else
                              {
                                nodes.push({
                                          data: resultset.subjects[i].getPrefLabel()[0],
                                          attr: {
                                                    id: resultset.subjects[i].uri.replace(/[^a-zA-Z0-9]+/g, ''),
                                                    title: resultset.subjects[i].uri,
                                                    rel: nodeType
                                                  },
                                          state: "closed"
                                        });
                              }
                            }

                            return(nodes);
                          },
                          "error": function(jqXHR, textStatus, error)
                          {
                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            var error = JSON.parse(jqXHR.responseText);

                            var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                            $('#messagesContainer').append('<div class="errorBox">' + errorMsg
                              + '</div>').hide().fadeIn("fast");
                          }
                        }
              },
      "search": {
                "ajax": {
                          type: "POST",
                          url: network.replace(/\/+$/,"") + "/search/",
                          data: function(query)
                          {
                            return("query=" + query +
                              "&datasets=" + dataset +
                              "&attributes=" + "all" +
                              "&page=" + "0" +
                              "&items=" + "20" +
                              "&include_aggregates=false" +
                              "&types=" + "http://www.w3.org/2002/07/owl#Class");
                          },
                          success: function(data)
                          {

                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            resultset = new Resultset(data);

                            var root = "http://www.w3.org/2002/07/owl#Thing";
                            var nodes = ["#" + root.replace(/[^a-zA-Z0-9]+/g, '')];

                            for(var i = 0; i < resultset.subjects.length; i++)
                            {
                              classTreeNodeBinder[resultset.subjects[i].uri.replace(/[^a-zA-Z0-9]+/g,
                                '')] = resultset.subjects[i].uri;
                              nodes.push("#" + resultset.subjects[i].uri.replace(/[^a-zA-Z0-9]+/g, ''));
                            }

                            if($("#searchBox").data("uri") != undefined && $("#searchBox").data("uri").uri != "")
                            {                                            
                              var superClasses = $.ajax({
                                        type: "POST",
                                        url: network.replace(/\/+$/,"") + "/ontology/read/",
                                        dataType: "json",
                                        data: ({
                                                  "function": "getSuperClasses",  
                                                  "reasoner": useReasoner,
                                                  "ontology": ontology,
                                                  parameters: "mode=descriptions" + ";" + "uri="
                                                    + $("#searchBox").data("uri").uri + ";" + "direct=0"
                                                }),
                                        async: false
                                      }).responseText;

                              //check if we got an error
                              var jsonResponseText = JSON.parse(superClasses);

                              if('level' in jsonResponseText && 'debugInformation' in jsonResponseText)
                              {
                                $('#messagesContainer').fadeOut("fast", function()
                                {
                                  $('#messagesContainer').empty();
                                });

                                var errorMsg = '[' + jsonResponseText.id + '] ' + jsonResponseText.name + ': '
                                  + jsonResponseText.description;

                                $('#messagesContainer').append('<div class="errorBox">' + errorMsg
                                  + '</div>').hide().fadeIn("fast");
                                return;
                              }

                              resultsetSuperClasses = new Resultset(jsonResponseText);

                              var pathClasses = getClassesTreeOrderedPath(resultsetSuperClasses,
                                "http://www.w3.org/2002/07/owl#Thing");
                              var path = [];

                              for(var i = 0; i < pathClasses.length; i++)
                              {
                                classTreeNodeBinder[pathClasses[i].replace(/[^a-zA-Z0-9]+/g,
                                  '')] = pathClasses[i];
                                path.push("#" + pathClasses[i].replace(/[^a-zA-Z0-9]+/g, ''));
                              }

                              return(path);
                            }
                          },
                          "error": function(jqXHR, textStatus, error)
                          {
                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            var error = JSON.parse(jqXHR.responseText);

                            var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                            $('#messagesContainer').append('<div class="errorBox">' + errorMsg
                              + '</div>').hide().fadeIn("fast");
                          },                          
                          dataType: "json"
                        }
              },
      "ui": {
                "select_limit": 1,
                "selected_parent_close": "select_parent",
                "initially_select": [uri.replace(/[^a-zA-Z0-9]+/g, '')]
              },
      "types": {
                "types": {
                          "internalClasses": {
                                    "valid_children": ["internalClasses", "default"],
                                    "icon": {
                                              "image": structOntologyModuleFullPath + '/imgs/folder_wrench.png'
                                            }
                                  },
                          "default": {
                                    "valid_children": ["internalClasses", "default"],
                                    "icon": {
                                              "image": structOntologyModuleFullPath + '/imgs/folder.png'
                                            }
                                  }
                        }
              },

      /* Case insensitive sort function */
      "sort": function(a, b)
      {
        return(this.get_text(a).toLowerCase() > this.get_text(b).toLowerCase() ? 1 : -1);
      },
    } 
  
  if(isAdmin)
  {
    jstreeStructure["plugins"] = ["themes", "json_data", "search", "ui", "contextmenu", "crrm", "hotkeys", "dnd", "types", "sort"];
    
    jstreeStructure["contextmenu"] = {
                "items": {
                          "create": {
                                    // The item label
                                    "label": "Create new class...",
                                    // The function to execute upon a click
                                    "action": function(obj)
                                    {
                                      this.create(obj);
                                    },    
                                    // All below are optional
                                    "_disabled": false, // clicking the item won't do a thing
                                    "_class": "contextMenuItem",
                                    icon: structOntologyModuleFullPath + '/imgs/folder_add.png',
                                    "separator_before": false, // Insert a separator before the item
                                    "separator_after": false
                                  },
                          "ccp": false,
                          "remove": {
                                    // The item label
                                    "label": "Delete",
                                    // The function to execute upon a click
                                    "action": function(obj)
                                    {

                                      this.remove(obj);
                                    },
                                    // All below are optional
                                    "_disabled": false, // clicking the item won't do a thing
                                    "_class": "contextMenuItem",
                                    icon: structOntologyModuleFullPath + '/imgs/folder_delete.png',
                                    "separator_before": false, // Insert a separator before the item
                                    "separator_after": false   // Insert a separator after the item
                                  },
                          "rename": {
                                    // The item label
                                    "label": "Rename",
                                    // The function to execute upon a click
                                    "action": function(obj)
                                    {

                                      this.rename(obj);
                                    },
                                    // All below are optional
                                    "_disabled": false, // clicking the item won't do a thing
                                    "_class": "contextMenuItem",
                                    icon: structOntologyModuleFullPath + '/imgs/folder_edit.png',
                                    "separator_before": false, // Insert a separator before the item
                                    "separator_after": false   // Insert a separator after the item
                                  },
                          "renameUri": {
                                    id: "renameUri",
                                    label: "Rename URI...",
                                    "_class": "contextMenuItem",
                                    icon: structOntologyModuleFullPath + '/imgs/folder_wrench.png',
                                    visible: function(node, treeObj)
                                    {
                                      if(node.length != 1)
                                      {
                                        return false;
                                      }
                                      else
                                      {
                                        return treeObj.check("creatable", node);
                                      }
                                    },
                                    action: function(node, treeObj)
                                    {
                                      createUriView();
                                    }
                                  }
                        }
              };
    jstreeStructure["dnd"] =  {
                "drop_finish": function(data)
                {
                  if(data.r.attr("id").search("structureSuperClass")
                    != -1 || data.r.attr("id").search("structureSubClass")
                      != -1 || data.r.attr("id").search("structureEquivalentClass")
                        != -1 || data.r.attr("id").search("structureDisjointWith") != -1)
                  {
                    data.r.data("value-uri", data.o.attr("title"));
                    data.r.val(data.o.text().replace(/^\s+|\s+$/g, ''));

                    addInputAutocomplete(data.r.data("attr-prefix"), data.r.data("element-id"),
                      data.r.data("jsdrop"), data.r.data("search-filter-attributes"),
                      data.r.data("search-filter-types"));

                    if(data.r.data("force-reload"))
                    {
                      reloadTree = true;
                    }
                  }
                },
                "drag_check": function(data)
                {
                  if(data.r.attr("id") == "httpwwww3org200207owlThing")
                  {
                    return false;
                  }
                  return {
                            after: false,
                            before: false,
                            inside: true
                          };
                }
              };
      jstreeStructure["crrm"] = {
                "move": {
                          "default_position": "inside",
                          "check_move": function(m)
                          {
                            return(true)
                          }
                        }
              };    
    
    
  }
  else
  {
    jstreeStructure["plugins"] = ["themes", "json_data", "search", "ui", "hotkeys", "types", "sort"]
  }
  
  

  jQuery("#classesTree").bind("loaded.jstree", function(event, data)
  {
    $("#httpwwww3org200207owlThing").attr("title", "http://www.w3.org/2002/07/owl#Thing");

    $.jstree._focused().set_type("internalClasses", $("#httpwwww3org200207owlThing"));

    // get the names of each loaded ontologies.
    $.ajax({                          
              type: "POST",
              url: network.replace(/\/+$/,"") + "/ontology/read/",
              data: "function=getLoadedOntologies&reasoner="+useReasoner+"&parameters=" + escape("mode=descriptions"),
              dataType: "json",
              success: function(msg)
              {

                // Process the resultset
                resultset = new Resultset(msg);

                for(var i = 0; i < resultset.subjects.length; i++)
                {
                  loadedOntologiesNames[resultset.subjects[i].uri] = resultset.subjects[i].getPrefLabel()[0];
                }

                // Change the name of the ontology in the breadcrumb
                $("#breadCrumbOntologyName").text(loadedOntologiesNames[ontology]);
              },
              error: function(jqXHR, textStatus, error)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                var error = JSON.parse(jqXHR.responseText);

                var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
              }
            });

    // get the name of all existing conStruct templates
    $.ajax({
              type: "GET",
              url: structOntologyModuleFullPath.replace(/\/+$/,"") + "/getTemplates.php",
              dataType: "json",
              success: function(msg)
              {
                existingTemplates = msg.templates;
              },
              error: function(jqXHR, textStatus, error)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                $('#messagesContainer').append(
                  '<div class="errorBox">Can\'t get the list of available conStruct templates</div>').hide().fadeIn(
                  "fast");
              }
            });
  }).jstree(jstreeStructure).bind("move_node.jstree", $.proxy(function(e, data)
  {

    var draggedConceptUri = classTreeNodeBinder[data.rslt.o.attr("id")];
    var parentDraggedConceptUri = classTreeNodeBinder[data.rslt.op.attr("id")];
    var targetParentConceptUri = classTreeNodeBinder[data.rslt.cr.attr("id")];

    $.ajax({
              type: "POST",
              url: network.replace(/\/+$/,"") + "/ontology/read/",
              dataType: "json",
              newName: data.rslt.new_name,
              "data": {
                        "function": "getClass",       
                        "reasoner": useReasoner,
                        ontology: dataset,
                        parameters: "uri=" + draggedConceptUri
                      },
              "success": function(data)
              {
                $('#messagesContainer').fadeOut("slow", function()
                {
                  $('#messagesContainer').empty();
                });

                // Here we read the resultset, and compose the JSON object to feed to jsTree
                resultset = new Resultset(data);

                resultset.subjects[0].removePredicateValues("http://umbel.org/umbel#superClassOf");

                resultset.subjects[0].removePredicateValue("http://www.w3.org/2000/01/rdf-schema#subClassOf",
                  parentDraggedConceptUri);
                resultset.subjects[0].addAttributeValue("http://www.w3.org/2000/01/rdf-schema#subClassOf", {
                          uri: targetParentConceptUri
                        });

                $.ajax({
                          type: "POST",
                          url: structModulesBaseUrl.replace(/\/+$/,"") + "/ontology/proxy",
                          dataType: "json",
                          "data": {
                                    ws: network.replace(/\/+$/,"") + "/ontology/update/",
                                    method: "post",
                                    accept: "application/json",
                                    params: "ontology=" + escape(ontology) + "&function=createOrUpdateEntity&parameters="
                                      + escape("document=" + escape(resultset.saveN3())) + ";"
                                      + escape("advancedIndexation=true")
                                  },
                          "success": function(data)
                          {
                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            $('#messagesContainer').append(
                              '<div class="successBox">Class successfully moved</div>').hide().fadeIn("fast");
                          },
                          "error": function(jqXHR, textStatus, error)
                          {
                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            if(jqXHR.status == 403)
                            {
                              $('#messagesContainer').append('<div class="errorBox">You need to have administrator permissions to modify an ontology.</div>').hide().fadeIn("fast");
                            }
                            else
                            {
                              $('#messagesContainer').append('<div class="errorBox">An error occured; please record this issue to the system administrator.</div>').hide().fadeIn("fast");
                            }
                          }
                        })
              },
              "error": function(jqXHR, textStatus, error)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                var error = JSON.parse(jqXHR.responseText);

                var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
              }
            })
  })).bind("remove.jstree", function(e, data)
  {

    // Delete the record
    $.ajax({
              type: "POST",
              url: structModulesBaseUrl.replace(/\/+$/,"") + "/ontology/proxy",
              dataType: "json",
              "data": {
                        ws: network.replace(/\/+$/,"") + "/ontology/delete/",
                        method: "post",
                        accept: "application/json",
                        params: "ontology=" + escape(ontology) + "&function=deleteClass&parameters="
                          + escape("uri=" + classTreeNodeBinder[data.args[0][0].id])
                      },
              "success": function(data)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                $("#classesTree").jstree("refresh", "httpwwww3org200207owlThing");

                $('#messagesContainer').append(
                  '<div class="successBox">Class successfully deleted</div>').hide().fadeIn("fast");
              },
              "error": function(jqXHR, textStatus, error)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                if(jqXHR.status == 403)
                {
                  $('#messagesContainer').append('<div class="errorBox">You need to have administrator permissions to modify an ontology.</div>').hide().fadeIn("fast");
                }
                else
                {
                  $('#messagesContainer').append('<div class="errorBox">An error occured; please record this issue to the system administrator.</div>').hide().fadeIn("fast");
                }
              }
            })
  }).bind("create.jstree", function(e, data)
  {

    var name = data.args[0].text().replace(/^\s+|\s+$/g, '');
    name = name.substring(0, name.search(/[\s]/));

    currentEntityResultset = new Resultset({
              prefixes: {
                        "owl": "http://www.w3.org/2002/07/owl#",
                        "rdf": "http://www.w3.org/1999/02/22-rdf-syntax-ns#",
                        "rdfs": "http://www.w3.org/2000/01/rdf-schema#",
                        "wsf": "http://purl.org/ontology/wsf#",
                        "aggr": "http://purl.org/ontology/aggregate#",
                        "ns0": "http://www.w3.org/2004/02/skos/core#",
                        "ns1": "http://umbel.org/umbel#"
                      },
              resultset: {
                        subject: [
                          {
                                    uri: "",
                                    type: "owl:Class",
                                    predicate: [
                                      {
                                                "rdfs:label": data.rslt.name
                                              },
                                      {
                                                "rdfs:subClassOf": {
                                                          "uri": classTreeNodeBinder[data.args[0].attr("id")],
                                                          "reify": [
                                                            {
                                                                      "type": "wsf:objectLabel",
                                                                      "value": name
                                                                    }
                                                          ]
                                                        }
                                              }
                                    ]
                                  }
                        ]
                      }
            });

    createClassView();
  }).bind("rename.jstree", function(e, data)
  {
    if(data.rslt.new_name == data.rslt.old_name)
    {
      // If the name didn't change, just continue without doing anything else.
      return;
    }

    // Get the record's description
    $.ajax({
              type: "POST",
              url: network.replace(/\/+$/,"") + "/ontology/read/",
              dataType: "json",
              newName: data.rslt.new_name,
              "data": {
                        "function": "getClass",
                        "reasoner": useReasoner,
                        ontology: ontology,
                        parameters: "uri=" + classTreeNodeBinder[data.args[0][0].id]
                      },
              "success": function(data)
              {
                resultset = new Resultset(data);

                resultset.subjects[0].rename(this.newName);

                // Now update the record's description
                $.ajax({
                          type: "POST",
                          url: structModulesBaseUrl.replace(/\/+$/,"") + "/ontology/proxy",
                          dataType: "json",
                          "data": {
                                    ws: network.replace(/\/+$/,"") + "/ontology/update/",
                                    method: "post",
                                    accept: "application/json",
                                    params: "ontology=" + escape(ontology) + "&function=createOrUpdateEntity&parameters="
                                      + escape("document=" + escape(resultset.saveN3())) + ";"
                                      + escape("advancedIndexation=true")
                                  },
                          "success": function(data)
                          {
                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            $('#messagesContainer').append(
                              '<div class="successBox">Class successfully renamed</div>').hide().fadeIn("fast");
                          },
                          "error": function(jqXHR, textStatus, error)
                          {
                            $('#messagesContainer').fadeOut("fast", function()
                            {
                              $('#messagesContainer').empty();
                            });

                            if(jqXHR.status == 403)
                            {
                              $('#messagesContainer').append('<div class="errorBox">You need to have administrator permissions to modify an ontology.</div>').hide().fadeIn("fast");
                            }
                            else
                            {
                              $('#messagesContainer').append('<div class="errorBox">An error occured; please record this issue to the system administrator.</div>').hide().fadeIn("fast");
                            }
                          }
                        })
              },
              "error": function(jqXHR, textStatus, error)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                var error = JSON.parse(jqXHR.responseText);

                var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
              }
            })
  }).bind('select_node.jstree', function(e, data)
  {
    var id = data.rslt.obj[0].attributes.id.nodeValue;
    
    /* 
      Here we are initializing the tree, once the first node is selected.
      This initialization is related to the pre-selection of a class, or a predicate, in the tree
      (Normally happen when a user clicks on a result of a search query.)
    */
    if(id == initiallyOpenedNodeIdReference)
    {
      if($("#classesTree").data("classUri") != "")
      {
        // Get the description of the target class to focus on
        var targetClass = $.ajax({
                  type: "POST",
                  url: network.replace(/\/+$/,"") + "/ontology/read/",
                  dataType: "json",
                  data: ({
                            "function": "getClass",
                            "reasoner": useReasoner,
                            "ontology": ontology,
                            parameters: "uri=" + $("#classesTree").data("classUri")
                          }),
                  async: false
                }).responseText;

        //check if we got an error
        var targetClass = JSON.parse(targetClass);

        if('level' in targetClass && 'debugInformation' in targetClass)
        {
          $('#messagesContainer').fadeOut("fast", function()
          {
            $('#messagesContainer').empty();
          });

          var errorMsg = '[' + targetClass.id + '] ' + targetClass.name + ': ' + targetClass.description;

          $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
          return;
        }

        targetClass = new Resultset(targetClass);

        var prefLabel = targetClass.subjects[0].getPrefLabel();

        // Do a search on the preffered label of that class
        $("#searchBox").data("uri", {
                  uri: $("#classesTree").data("classUri")
                });

        $("#classesTree").jstree("search", prefLabel);
      }      

      if($("#classesTree").data("propertyUri") != "")
      {
        // Get the description of the target property to focus on
        var targetProperty = $.ajax({
                  type: "POST",
                  url: network.replace(/\/+$/,"") + "/ontology/read/",
                  dataType: "json",
                  data: ({
                            "function": "getProperty",
                            "reasoner": useReasoner,
                            "ontology": ontology,
                            parameters: "uri=" + $("#classesTree").data("propertyUri")
                          }),
                  async: false
                }).responseText;

        // Switch to the property tree view control
        togglePropertiesView();

        // Do a search on the preffered label of that property
        var targetProperty = JSON.parse(targetProperty);

        if('level' in targetProperty && 'debugInformation' in targetProperty)
        {
          $('#messagesContainer').fadeOut("fast", function()
          {
            $('#messagesContainer').empty();
          });

          var errorMsg = '[' + targetProperty.id + '] ' + targetProperty.name + ': ' + targetProperty.description;

          $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
          return;
        }

        targetProperty = new Resultset(targetProperty);

        var prefLabel = targetProperty.subjects[0].getPrefLabel();

        // Do a search on the preffered label of that class
        $("#searchBox").data("uri", {
                  uri: $("#classesTree").data("propertyUri")
                });

        $("#propertiesTree").jstree("search", prefLabel);
      }      
    }

    lastSelectedClassNode = id;

    var uri = classTreeNodeBinder[id];

    $('#ontologyViewColumRecord').fadeTo('fast', 0.5, function(){});

    $.ajax({
              type: "POST",
              url: network.replace(/\/+$/,"") + "/ontology/read/",
              dataType: "json",
              "data": {
                        "function": "getClass",
                        "reasoner": useReasoner,
                        ontology: ontology,
                        parameters: "uri=" + uri
                      },
              "success": function(data)
              {

                // Here we read the resultset, and compose the JSON object to feed to jsTree
                currentEntityResultset = new Resultset(data);

                createClassView();
              },
              "error": function(jqXHR, textStatus, error)
              {
                $('#messagesContainer').fadeOut("fast", function()
                {
                  $('#messagesContainer').empty();
                });

                var error = JSON.parse(jqXHR.responseText);

                var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
              }
            })
  })
}

function createUriView()
{
  var uri = currentEntityResultset.subjects[0].uri;

  $('#messagesContainer').fadeOut("fast", function()
  {
    $('#messagesContainer').empty();
  });

  $('#ontologyViewColumRecord').fadeTo('fast', 0.5, function(){});

  // Empty the record section.
  $("#ontologyViewColumRecord").empty();

  // Generate the URI Rename section table
  $("#ontologyViewColumRecord").append('<table id="uriRenameTable">');
  $("#uriRenameTable").append('<tr><td id="uriRenameTableHeader" colspan="2">Rename URI</td></tr>');

  $("#uriRenameTable").append(
    '<tr class="uriRenameRow"><td class="uriRenameText" valign="top">URI:</td><td valign="top"><input id="uriRenameInputText" class="uriRenameInputText" type="text" value="'
    + uri + '" /></td></tr>');

  $('#ontologyViewColumRecord').append(
    '<div class="buttonsContainer"><input title="Rename" id="renameButton" type="submit" value="Rename" onclick="renameUri(\''
    + uri + '\');" class="renameButton" /></div>');

  $('#ontologyViewColumRecord').fadeTo('fast', 1, function(){});
}

function createIntermediaryUriView()
{
  $('#messagesContainer').fadeOut("fast", function()
  {
    $('#messagesContainer').empty();
  });

  $('#ontologyViewColumRecord').fadeTo('fast', 0.5, function(){});

  // Empty the record section.
  $("#ontologyViewColumRecord").empty();

  // Generate the URI Rename section table
  $("#ontologyViewColumRecord").append('<table id="uriRenameTable">');
  $("#uriRenameTable").append('<tr><td id="uriRenameTableHeader" colspan="2">Name URI</td></tr>');

  $("#uriRenameTable").append(
    '<tr class="uriRenameRow"><td class="uriRenameText" valign="top" style="width: 100px;">URI ending:</td><td valign="top"><input id="uriRenameInputText" class="uriRenameInputText" type="text" value="" /></td></tr>\
     <tr class="uriRenameRow"><td colspan="2"><em>Note: the URI ending shouldn\'t include the namespace. The namespace that will be used is the one of the ontology.</em></td></tr>');

  $('#ontologyViewColumRecord').append(
    '<div class="buttonsContainer"><input title="Name" id="renameButton" type="submit" value="Name" onclick="nameUri();" class="renameButton" /></div>');

  $('#ontologyViewColumRecord').fadeTo('fast', 1, function(){});
}

function createClassView()
{
  var uri = currentEntityResultset.subjects[0].uri;

  if(uri == "")
  {
    // ask the user to enter a URI for this new entity

    createIntermediaryUriView();

    return;
  }

  $('#messagesContainer').fadeOut("fast", function()
  {
    $('#messagesContainer').empty();
  });

  // All the attributes that have been processed by the default UI.
  // all the remaining ones will be displayed in the "Others" section.
  var processedAttributes = [];

  // Empty the record section.
  $("#ontologyViewColumRecord").empty();

  // Generate the record view panel.

  // Generate the Annotations section table 
  if(!isAdmin)
  {
    $("#ontologyViewColumRecord").append('<div id="teaserBox">');
    
    // Add the preferred label
    var prefLabel = currentEntityResultset.subjects[0].getPrefLabelTuple();

    if(prefLabel.length > 0)
    {
      var prefLabels = "";

      for(var i = 0; i < prefLabel.length; i++)
      {
        prefLabels += '<h2 class="readingModePrefLabel">' + prefLabel[i].label + '</h2>'
      }

      for(var i = 0; i < prefLabel.length; i++)
      {
        processedAttributes.push(prefLabel[i].attr);
      }      

      $("#teaserBox").append(prefLabels);
    }    
    
    var altLabels = currentEntityResultset.subjects[0].getAltLabelsTuple();

    if(altLabels.length > 0)
    {
      var altLabelsStrings = '<div class="readingModeAltLabels"><em>(';
      
      for(var i = 0; i < altLabels.length; i++)
      {   
        altLabelsStrings += altLabels[i].label + ", ";
      }
      
      altLabelsStrings = altLabelsStrings.substring(0, altLabelsStrings.length - 2);

      altLabelsStrings += ")</em></div>";
      
      $("#teaserBox").append(altLabelsStrings);
      
      for(var i = 0; i < altLabels.length; i++)
      {
        processedAttributes.push(altLabels[i].attr);
      }        
    }
    
    var description = currentEntityResultset.subjects[0].getDescriptionTuple();

    if(description.length > 0)
    {
      var descriptions = "";
      
      for(var i = 0; i < description.length; i++)
      {
        descriptions += '<div class="readingModeDescription">' + description[i].description + '</div>';
      }
      
      for(var i = 0; i < description.length; i++)
      {
        processedAttributes.push(description[i].attr);
      }        
      
      $("#teaserBox").append(descriptions);
    }    
    
    $("#ontologyViewColumRecord").append('<div style="padding-bottom: 20px;">&nbsp;</div>');
  }
  else
  {
    $("#ontologyViewColumRecord").append('<table id="annotationsTable">');
    $("#annotationsTable").append(
      '<tr><td id="annotationsTableHeader" colspan="2">Annotations <img id="annotationsHeaderImg" src="'
      + structOntologyModuleFullPath + '/imgs/arrow_up.png" title="Collapse panel" /></td></tr>');

    $("#annotationsTableHeader").click(function()
    {
      if($(".attributeRow").is(':hidden'))
      {
        $(".attributeRow").fadeIn("slow", function()
        {
          $("#annotationsHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
          $("#annotationsHeaderImg").attr("title", "Collapse panel");
        });
      }
      else
      {
        $(".attributeRow").fadeOut("slow", function()
        {
          $("#annotationsHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
          $("#annotationsHeaderImg").attr("title", "Extends panel");
        });
      }
    })

    // Add the preferred label
    var prefLabel = currentEntityResultset.subjects[0].getPrefLabelTuple();

    if(prefLabel.length > 0)
    {
      var inputs = "";

      for(var i = 0; i < prefLabel.length; i++)
      {
        inputs += '<input id="inputPrefLabel_' + i + '" class="attributeInputText" type="text" value="'
          + prefLabel[i].label + '" /><br />';

        $('#inputPrefLabel_' + i).data("attr-uri", prefLabel[i].attr);
      }

      $("#annotationsTable").append(
        '<tr class="attributeRow"><td class="attributeText" valign="top">Preferred Label(s):</td><td valign="top">'
        + inputs + '</td></tr>');

      // Set the data associated with all created elements.
      for(var i = 0; i < prefLabel.length; i++)
      {
        $('#inputPrefLabel_' + i).data("attr-uri", prefLabel[i].attr);
        $('#inputPrefLabel_' + i).data("value-type", "literal");

        processedAttributes.push(prefLabel[i].attr);
      }
    }

    // Add alternative labels
    var altLabels = currentEntityResultset.subjects[0].getAltLabelsTuple();

    var inputs = "";
    var hasValues = false;

    if(altLabels.length > 0)
    {
      for(var i = 0; i < altLabels.length; i++)
      {
        if(i == altLabels.length)
        {
          inputs += '<input id="inputAltLabel_' + i + '" class="attributeInputText" type="text" value="" />';
          inputs += '<img id="inputAltLabel_' + i + '_img" class="inputAddImg" src="' + structOntologyModuleFullPath
            + '/imgs/bullet_add.png" title="add" /><br />';
        }
        else
        {
          inputs += '<input id="inputAltLabel_' + i + '" class="attributeInputText" type="text" value="'
            + altLabels[i].label + '" />';
          inputs += '<img id="inputAltLabel_' + i + '_img" class="inputAddImg" src="' + structOntologyModuleFullPath
            + '/imgs/bullet_delete.png" title="remove" /><br />';
        }
      }
    }
    else
    {
      inputs += '<input id="inputAltLabel_0" class="attributeInputText" type="text" value="" />';
      inputs += '<img id="inputAltLabel_0_img" class="inputAddImg" src="' + structOntologyModuleFullPath
        + '/imgs/bullet_add.png" title="add" /><br />';
    }

    $("#annotationsTable").append(
      '<tr class="attributeRow"><td class="attributeText" valign="top">Alternative Label:</td><td valign="top">'
      + inputs + '</td></tr>');

    // Set the data associated with all created elements.
    if(altLabels.length <= 0)
    {
      $('#inputAltLabel_0').data("attr-uri", "http://www.w3.org/2004/02/skos/core#altLabel");
      $('#inputAltLabel_0').data("value-type", "literal");
      $('#inputAltLabel_0').data("element-id", 0);
      $('#inputAltLabel_0').data("attr-prefix", "inputAltLabel");
      $('#inputAltLabel_0').data("value-uri", "");

      $('#inputAltLabel_0_img').click(function()
      {
        var id = $(this).attr("id").replace("_img", "");

        addInputAutocomplete($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"), false,
          "http://purl.org/ontology/iron#prefLabel", "http://www.w3.org/2002/07/owl#Class");
      });
    }
    else
    {
      for(var i = 0; i <= altLabels.length; i++)
      {
        if(i == altLabels.length)
        {
          $('#inputAltLabel_' + i).data("attr-uri", "http://www.w3.org/2004/02/skos/core#altLabel");
          $('#inputAltLabel_' + i).data("value-type", "literal");
          $('#inputAltLabel_' + i).data("element-id", i);
          $('#inputAltLabel_' + i).data("attr-prefix", "inputAltLabel");
          $('#inputAltLabel_' + i).data("value-uri", "");

          $('#inputAltLabel_' + i + '_img').click(function()
          {
            var id = $(this).attr("id").replace("_img", "");

            addInputAutocomplete($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"), false,
              "http://purl.org/ontology/iron#prefLabel", "http://www.w3.org/2002/07/owl#Class");
          });
        }
        else
        {
          $('#inputAltLabel_' + i).data("attr-uri", altLabels[i].attr);
          $('#inputAltLabel_' + i).data("value-type", "literal");
          $('#inputAltLabel_' + i).data("element-id", i);
          $('#inputAltLabel_' + i).data("attr-prefix", "inputAltLabel");
          $('#inputAltLabel_' + i).data("value-uri", altLabels[i].label);

          $('#inputAltLabel_' + i + '_img').click(function()
          {
            var id = $(this).attr("id").replace("_img", "");

            removeInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));
          });
          processedAttributes.push(altLabels[i].attr);
        }
      }
    }

    // Add Description
    var description = currentEntityResultset.subjects[0].getDescriptionTuple();

    var inputs = "";

    if(description.length > 0)
    {
      for(var i = 0; i < description.length; i++)
      {
        inputs += '<textarea id="inputDescription_' + i + '" class="attributeInputTextArea">' + description[i].description
          + '</textarea>';
      }
    }
    else
    {
      inputs += '<textarea id="inputDescription_0" class="attributeInputTextArea"></textarea>';
    }

    $("#annotationsTable").append(
      '<tr class="attributeRow"><td class="attributeText" valign="top">Description:</td><td valign="top">'
      + inputs + '</td></tr>');

    if(description.length <= 0)
    {
      $('#inputDescription_0').data("attr-uri", "http://www.w3.org/2000/01/rdf-schema#comment");
      $('#inputDescription_0').data("value-type", "literal");
    }
    else
    {
      // Set the data associated with all created elements.
      for(var i = 0; i < description.length; i++)
      {
        $('#inputDescription_' + i).data("attr-uri", description[i].attr);
        $('#inputDescription_' + i).data("value-type", "literal");

        processedAttributes.push(description[i].attr);
      }
    }
  }


  // Display all the structure related attributes & values
  $("#ontologyViewColumRecord").append('<table id="structureTable">');
  $("#structureTable").append(
    '<tr><td id="structureTableHeader" colspan="2">Structure <img id="structureHeaderImg" src="'
    + structOntologyModuleFullPath + '/imgs/arrow_up.png" title="Collapse panel" /></td></tr>');

  $("#structureTableHeader").click(function()
  {
    if($(".structureRow").is(':hidden'))
    {
      $(".structureRow").fadeIn("slow", function()
      {
        $("#structureHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
        $("#structureHeaderImg").attr("title", "Collapse panel");
      });
    }
    else
    {
      $(".structureRow").fadeOut("slow", function()
      {
        $("#structureHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
        $("#structureHeaderImg").attr("title", "Extends panel");
      });
    }
  })

  addAttributeInputAutocomplete("structureTable", "structureSubClass", "structure", "Sub Class of",
    "http://www.w3.org/2000/01/rdf-schema#subClassOf", true, "http://purl.org/ontology/iron#prefLabel",
    "http://www.w3.org/2002/07/owl#Class", true);
  processedAttributes.push("http://www.w3.org/2000/01/rdf-schema#subClassOf");

  addAttributeInputAutocomplete("structureTable", "structureSuperClass", "structure", "Super Class of",
    "http://umbel.org/umbel#superClassOf", true, "http://purl.org/ontology/iron#prefLabel",
    "http://www.w3.org/2002/07/owl#Class", true);
  processedAttributes.push("http://umbel.org/umbel#superClassOf");

  addAttributeInputAutocomplete("structureTable", "structureEquivalentClass", "structure", "Equivalent to",
    "http://www.w3.org/2002/07/owl#equivalentClass", true, "http://purl.org/ontology/iron#prefLabel",
    "http://www.w3.org/2002/07/owl#Class", true);
  processedAttributes.push("http://www.w3.org/2002/07/owl#equivalentClass");

  addAttributeInputAutocomplete("structureTable", "structureDisjointWith", "structure", "Disjoint with",
    "http://www.w3.org/2002/07/owl#disjointWith", true, "http://purl.org/ontology/iron#prefLabel",
    "http://www.w3.org/2002/07/owl#Class", true);
  processedAttributes.push("http://www.w3.org/2002/07/owl#disjointWith");


  // Display related instances
  $("#ontologyViewColumRecord").append('<table id="instancesTable">');
  $("#instancesTable").append(
    '<tr><td id="instancesTableHeader" colspan="2">Instances <img id="instancesHeaderImg" src="'
    + structOntologyModuleFullPath + '/imgs/arrow_down.png" title="Extends panel" /></td></tr>');
  $("#instancesTable").append(
    '<tr class="instanceRow notThisInstanceRow"><td valign="top" colspan="2" id="topInstancesRow"></td></tr>');
  $(".instanceRow").hide();

  $("#instancesTableHeader").click(function()
  {
    if($('#topInstancesRow').data("initialized") != true)
    {
      $('#topInstancesRow').data("initialized", true);
    }
    else
    {
      if($(".instanceRow").is(':hidden'))
      {
        $("#topInstancesRow").empty();
        $(".instanceRow").fadeIn("slow", function()
        {
          $("#instancesHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
          $("#instancesHeaderImg").attr("title", "Collapse panel");
        });
      }
      else
      {
        $(".instanceRow").fadeOut("slow", function()
        {
          $("#instancesHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
          $("#instancesHeaderImg").attr("title", "Extends panel");
        });
      }

      return;
    }

    if($(".instanceRow").is(':hidden'))
    {
      $("#topInstancesRow").empty();

      $("#topInstancesRow").append('<img src="' + structOntologyModuleFullPath
        + '/imgs/ajax-loading-bar.gif" width="220" height="19" />');

      $(".instanceRow").fadeIn("slow", function()
      {
        $("#instancesHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
        $("#instancesHeaderImg").attr("title", "Collapse panel");
      });

      $.ajax({
                type: "POST",
                url: network.replace(/\/+$/,"") + "/search/",
                dataType: "json",
                data: {
                          types: uri,
                          page: 0,
                          items: 20,
                          include_aggregates: "false"
                        },
                "success": function(data)
                {
                  instances = new Resultset(data);

                  $("#topInstancesRow").empty();

                  for(var i = 0; i < instances.subjects.length; i++)
                  {
                    var prefLabel = instances.subjects[i].getPrefLabel();
                    var instanceUri = instances.subjects[i].uri;
                    var datasets = instances.subjects[i].getDatasets();

                    $("#instancesTable").append('<tr class="instanceRow"><td valign="top" colspan="2"><a href="'
                      + structModulesBaseUrl + 'view/?uri=' + escape(instanceUri) + '&dataset=' + escape(datasets[0])
                        + '">' + prefLabel + '</a></td></tr>');
                  }

                  if(instances.subjects.length <= 0)
                  {
                    $("#topInstancesRow").append('No instance records instantiated using this class');
                  }
                  else
                  {
                    if((i % 20 == 0) && (i > 0))
                    {
                      $("#instancesTable").append(
                        '<tr class="instanceRow footerInstanceRow"><td valign="top" colspan="2"><a href="'
                        + structModulesBaseUrl + 'browse/?browse=true&attribute=all&type=' + escape(uri)
                          + '&dataset=all&page=0"><img id="instancesBrowseImg" src="' + structOntologyModuleFullPath
                          + '/imgs/world_link.png" />Browse for all records of that type</a></td></tr>');
                      $("#instancesTable").append(
                        '<tr class="instanceRow footerInstanceRow"><td valign="top" colspan="2"><a href="'
                        + structModulesBaseUrl + 'search/?filter_types_1=' + escape(uri)
                          + '&query=&filter=on"><img id="instancesSearchImg" src="' + structOntologyModuleFullPath
                          + '/imgs/magnifier.png" />Search for records of that type</a></td></tr>');
                    }
                  }
                },
                "error": function(jqXHR, textStatus, error)
                {
                  $("#topInstancesRow").empty();
                }
              })
    }
    else
    {
      $(".instanceRow").fadeOut("slow", function()
      {
        $("#instancesHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
        $("#instancesHeaderImg").attr("title", "Extends panel");
      });
    }
  })


  // Display all characteristics of this class
  $("#ontologyViewColumRecord").append('<table id="characteristicsTable">');
  $("#characteristicsTable").append(
    '<tr><td id="characteristicsTableHeader" colspan="2">Characteristics <img id="characteristicsHeaderImg" src="'
    + structOntologyModuleFullPath + '/imgs/arrow_up.png" title="Collapse panel" /></td></tr>');

  $("#characteristicsTableHeader").click(function()
  {
    if($(".characteristicRow").is(':hidden'))
    {
      $(".characteristicRow").fadeIn("slow", function()
      {
        $("#characteristicsHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
        $("#characteristicsHeaderImg").attr("title", "Collapse panel");
      });
    }
    else
    {
      $(".characteristicRow").fadeOut("slow", function()
      {
        $("#characteristicsHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
        $("#characteristicsHeaderImg").attr("title", "Extends panel");
      });
    }
  })

  addAttributeInputAutocomplete("characteristicsTable", "characteristics", "characteristics", "Has Characteristic",
    "http://umbel.org/umbel#hasCharacteristic", false, "http://purl.org/ontology/iron#prefLabel",
    "http://www.w3.org/2002/07/owl#ObjectProperty;http://www.w3.org/2002/07/owl#DatatypeProperty;http://www.w3.org/1999/02/22-rdf-syntax-ns#Property",
    false);
  processedAttributes.push("http://umbel.org/umbel#hasCharacteristic");
  
  // Hide the section if it is empty.
  if(!isAdmin && $("#characteristicsTable tr").length <= 1)
  {
    $("#characteristicsTable").hide();
  }

  // Display advanced options
  if(isAdmin)
  {
    $("#ontologyViewColumRecord").append('<table id="advancedTable">');
    $("#advancedTable").append('<tr><td id="advancedTableHeader" colspan="2">Advanced <img id="advancedHeaderImg" src="'
      + structOntologyModuleFullPath + '/imgs/arrow_down.png" title="Extend panel" /></td></tr>');

    $("#advancedTableHeader").click(function()
    {
      if($(".advancedRow").is(':hidden'))
      {
        $(".advancedRow").fadeIn("slow", function()
        {
          $("#advancedHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
          $("#advancedHeaderImg").attr("title", "Collapse panel");
        });
      }
      else
      {
        $(".advancedRow").fadeOut("slow", function()
        {
          $("#advancedHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
          $("#advancedHeaderImg").attr("title", "Extends panel");
        });
      }

      if($('#templatesSectionTop').data("initialized") != true)
      {
        $("#templatesSectionTop").empty();

        $("#templatesSectionTop").append('<img src="' + structOntologyModuleFullPath
          + '/imgs/ajax-loading-bar.gif" width="220" height="19" />');

        $.ajax({
                  type: "POST",
                  url: network.replace(/\/+$/,"") + "/ontology/read/",
                  dataType: "json",
                  data: ({
                            "function": "getSuperClasses",
                            "reasoner": useReasoner,
                            "ontology": ontology,
                            parameters: "mode=descriptions" + ";" + "uri=" + uri + ";" + "direct=0"
                          }),
                  "success": function(data)
                  {
                    resultset = new Resultset(data);

                    var templates = [];

                    for(var i = 0; i < resultset.subjects.length; i++)
                    {
                      var superClassUri =
                        resultset.prefixize(resultset.subjects[i].uri).replace(/[^A-Za-z0-9]/, '_') + '.html';

                      for(var u = 0; u < existingTemplates.length; u++)
                      {
                        if(superClassUri.toLowerCase() == existingTemplates[u].toLowerCase())
                        {
                          templates.push(existingTemplates[u]);
                        }
                      }
                    }

                    $("#templatesSectionTop").empty();

                    if(templates.length == 0)
                    {
                      templates = ["owl_thing.html"]
                    }

                    for(var i = 0; i < templates.length; i++)
                    {
                      $("#advancedTable").append(
                        '<tr class="advancedRow"><td class="template-item" colspan="2"><img class="templateImg" src="'
                        + structOntologyModuleFullPath + '/imgs/color_swatch.png" title="Display template" />'
                        + templates[i] + '</td></tr>');
                    }
                  },
                  "error": function(jqXHR, textStatus, error)
                  {
                    $("#templatesSectionTop").empty();
                    
                    $('#messagesContainer').fadeOut("fast", function()
                    {
                      $('#messagesContainer').empty();
                    });

                    var error = JSON.parse(jqXHR.responseText);

                    var errorMsg = '[' + error.id + '] ' + error.name + ': ' + error.description;

                    $('#messagesContainer').append('<div class="errorBox">' + errorMsg
                      + '</div>').hide().fadeIn("fast");
                  }                  
                })

        $('#templatesSectionTop').data("initialized", true);
      }
    });

    $("#advancedTable").append(
      '<tr class="advancedRow"><td class="advancedSectionHeader" colspan="2">Semantic Components Settings</td></tr>');

    addAttributeInput("advancedTable", "shortLabel", "advanced", "Short label", "http://purl.org/ontology/sco#shortLabel")
    processedAttributes.push("http://purl.org/ontology/sco#shortLabel");

    addAttributeInputAutocomplete("advancedTable", "displayControl", "advanced", "Display component",
      "http://purl.org/ontology/sco#displayControl", false, "http://purl.org/ontology/iron#prefLabel",
      "http://purl.org/ontology/sco#Component", false);
    processedAttributes.push("http://purl.org/ontology/sco#displayControl");

    addAttributeInputAutocomplete("advancedTable", "relationBrowserNodeType", "advanced", "Relation browser node type",
      "http://purl.org/ontology/sco#relationBrowserNodeType", false, "http://purl.org/ontology/iron#prefLabel",
      "http://www.w3.org/2002/07/owl#Class", false);
    processedAttributes.push("http://purl.org/ontology/sco#relationBrowserNodeType");

    addAttributeInput("advancedTable", "mapMarkerImageUrl", "advanced", "Map marker image URL",
      "http://purl.org/ontology/sco#mapMarkerImageUrl")
    processedAttributes.push("http://purl.org/ontology/sco#mapMarkerImageUrl");


  //$("#advancedTable").append('<tr class="advancedRow"><td class="advancedSectionHeader" colspan="2">UMBEL Settings</td></tr>');
    $("#advancedTable").append(
      '<tr class="advancedRow"><td class="advancedSectionHeader" colspan="2">Display Settings (in selection order)</td></tr>');
    $("#advancedTable").append('<tr class="advancedRow"><td id="templatesSectionTop" colspan="2"></td></tr>');

    $('#templatesSection').data("initialized", false);

    $(".advancedRow").hide();      
  }     

  var sectionHeaderDisplayed = false;

  if(typeof (currentEntityResultset.subjects[0]) == 'object' && 'predicate' in currentEntityResultset.subjects[0])
  {
    var index = 0;

    for(var i = 0; i < currentEntityResultset.subjects[0].predicate.length; i++)
    {
      for(var predicate in currentEntityResultset.subjects[0].predicate[i])
      {
        if(currentEntityResultset.unprefixize(predicate) == "http://umbel.org/umbel#superClassOf")
        {
          continue;
        }

        var attrUri = currentEntityResultset.unprefixize(predicate);

        if(processedAttributes.indexOf(attrUri) == -1)
        {
          if(!sectionHeaderDisplayed)
          {
            // Display all the attributes/values that haven't be handled in any other section above.
            $("#ontologyViewColumRecord").append('<table id="othersTable">');
            $("#othersTable").append('<tr><td id="othersTableHeader" colspan="2">Others <img id="othersHeaderImg" src="'
              + structOntologyModuleFullPath + '/imgs/arrow_up.png" title="Collapse panel" /></td></tr>');

            $("#othersTableHeader").click(function()
            {
              if($(".otherRow").is(':hidden'))
              {
                $(".otherRow").fadeIn("slow", function()
                {
                  $("#othersHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_up.png');
                  $("#othersHeaderImg").attr("title", "Collapse panel");
                });
              }
              else
              {
                $(".otherRow").fadeOut("slow", function()
                {
                  $("#othersHeaderImg").attr("src", structOntologyModuleFullPath + '/imgs/arrow_down.png');
                  $("#othersHeaderImg").attr("title", "Extends panel");
                });
              }
            })

            sectionHeaderDisplayed = true;
          }

          var attrLabel = "";

          if(attrUri.lastIndexOf("#") != -1)
          {
            attrLabel = attrUri.substring(attrUri.lastIndexOf("#") + 1);
          }
          else if(attrUri.lastIndexOf("/") != -1)
          {
            attrLabel = attrUri.substring(attrUri.lastIndexOf("/") + 1);
          }
          else
          {
            attrLabel = attrUri;
          }

          var values = currentEntityResultset.subjects[0].getPredicateValues(attrUri);

          var inputs = "";

          for(var ii = 0; ii < values.length; ii++)
          {
            var value = "";

            if(typeof (values[ii]) == 'object' && 'uri' in values[ii])
            {
              value = values[ii].uri;
            }
            else
            {
              value = values[ii];
            }

            if(isAdmin)
            {
              inputs += '<input type="text" id="inputOthers_' + index + '_' + ii
                + '" class="attributeInputTextArea" value="' + value + '" /><br />';
            }
            else
            {
              inputs += '<div id="inputOthers_' + index + '_' + ii
                     + '" class="attributeInputTextArea">' + value + '</div>'
            }            
          }

          $("#othersTable").append('<tr class="otherRow"><td class="attributeText" valign="top" title="' + attrUri
            + '">' + attrLabel + ':</td><td valign="top">' + inputs + '</td></tr>');

          // Set the data associated with all created elements.
          if(isAdmin)
          {
            for(var ii = 0; ii < values.length; ii++)
            {
              if(typeof (values[ii]) == 'object' && 'uri' in values[ii])
              {
                $('#inputOthers_' + index + '_' + ii).data("value-type", "uri");
              }
              else
              {
                $('#inputOthers_' + index + '_' + ii).data("value-type", "literal");
              }

              $('#inputOthers_' + index + '_' + ii).data("attr-uri", attrUri);
              processedAttributes.push(attrUri);
            }
          }

          index++;
        }
      }
    }
  }

  if(isAdmin)
  {
    $('#ontologyViewColumRecord').append(
      '<div class="buttonsContainer"><input title="Save changes" id="saveButton" type="submit" value="Save" onclick="save();" class="saveButton" /></div>');
  }

  $('#ontologyViewColumRecord').fadeTo('fast', 1, function(){});
}

function nameUri()
{
  $("#renameButton").hide();

  currentEntityResultset.subjects[0].uri = $("#uriRenameInputText").val();

  $('#messagesContainer').fadeOut("fast", function()
  {
    $('#messagesContainer').empty();
  });

  reloadTree = true;

  switch(currentView)
  {
    case "classes":
      createClassView();
      break;

    case "properties":
      createPropertyView();
      break;
  }
}

function renameUri(oldUri)
{
  $("#renameButton").hide();

  if($("#renameButtonAjax").length <= 0)
  {
    $("#ontologyViewColumRecord").append('<div class="buttonsContainer"><img id="renameButtonAjax" src="'
      + structOntologyModuleFullPath + '/imgs/ajax-loading-bar.gif" width="220" height="19" /></div>');
  }
  else
  {
    $("#renameButtonAjax").show();
  }

  $('#messagesContainer').fadeOut("fast", function()
  {
    $('#messagesContainer').empty();
  });

  $.ajax({
            type: "POST",
            url: structModulesBaseUrl.replace(/\/+$/,"") + "/ontology/proxy",
            dataType: "json",
            "data": {
                      ws: network.replace(/\/+$/,"") + "/ontology/update/",
                      method: "post",
                      accept: "application/json",
                      params: "ontology=" + escape(ontology) + "&function=updateEntityUri&parameters="
                        + escape("oldUri=" + escape(oldUri)) + ";"
                        + escape("newUri=" + escape($("#uriRenameInputText").val())) + ";"
                        + escape("advancedIndexation=true")
                    },
            "success": function(data)
            {
              $('#messagesContainer').append('<div class="successBox">URI successfully redefined</div>').hide().fadeIn(
                "fast");

              $("#renameButtonAjax").hide();
              $("#renameButton").show();

              $("#classesTree").jstree("refresh", "httpwwww3org200207owlThing");
              reloadTree = false;
            },
            "error": function(jqXHR, textStatus, error)
            {
              $('#messagesContainer').fadeOut("fast", function()
              {
                $('#messagesContainer').empty();

                $("#renameButtonAjax").hide();
                $("#renameButton").show();
              });

              if(jqXHR.status == 403)
              {
                $('#messagesContainer').append('<div class="errorBox">You need to have administrator permissions to modify an ontology.</div>').hide().fadeIn("fast");
              }
              else
              {
                $('#messagesContainer').append('<div class="errorBox">An error occured; please record this issue to the system administrator.</div>').hide().fadeIn("fast");
              }
            }
          })
}

function save()
{
  $("#saveButton").hide();

  if($("#saveButtonAjax").length <= 0)
  {
    $("#ontologyViewColumRecord").append('<div class="buttonsContainer"><img id="saveButtonAjax" src="'
      + structOntologyModuleFullPath + '/imgs/ajax-loading-bar.gif" width="220" height="19" /></div>');
  }
  else
  {
    $("#saveButtonAjax").show();
  }

  $('#messagesContainer').fadeOut("fast", function()
  {
    $('#messagesContainer').empty();
  });

  // First, let's take into account any changes that may have occured in the record's view page

  var predicates = [];

  // Get first Type
  var type = currentEntityResultset.subjects[0].type;

  // @TODO: put all other types into the "predicates" var

  // Get prefLabel(s)
  for(i = 0; i < 256; i++)
  {
    if($("#inputPrefLabel_" + i).length > 0 && $("#inputPrefLabel_" + i).val().length > 0)
    {
      var prefLabelObj = {
              };

      prefLabelObj[$("#inputPrefLabel_" + i).data("attr-uri")] = $("#inputPrefLabel_" + i).val();
      predicates.push(prefLabelObj);
    }
    else
    {
      break;
    }
  }

  // Get altLabels(s)
  for(i = 0; i < 256; i++)
  {
    if($("#inputAltLabel_" + i).length > 0 && $("#inputAltLabel_" + i).val().length > 0)
    {
      var altLabelObj = {
              };

      altLabelObj[$("#inputAltLabel_" + i).data("attr-uri")] = $("#inputAltLabel_" + i).val();
      predicates.push(altLabelObj);
    }
    else
    {
      break;
    }
  }

  // Get descriptions(s)
  for(i = 0; i < 256; i++)
  {
    if($("#inputDescription_" + i).length > 0 && $("#inputDescription_" + i).val().length > 0)
    {
      var descriptionObj = {
              };

      descriptionObj[$("#inputDescription_" + i).data("attr-uri")] = $("#inputDescription_" + i).val();
      predicates.push(descriptionObj);
    }
    else
    {
      break;
    }
  }

  // Get Sub Classes relationship(s)
  for(i = 0; i < 256; i++)
  {
    if($("#structureSubClass_" + i).length > 0 && $("#structureSubClass_" + i).val().length > 0)
    {
      var subClassObj = {
              };

      subClassObj[$('#structureSubClass_'
        + i).data("attr-uri")] = {
                uri: $('#structureSubClass_' + i).data("value-uri")
              };

      predicates.push(subClassObj);
    }
    else
    {
      break;
    }
  }

  // Get Disjoint with relationship(s)
  for(i = 0; i < 256; i++)
  {
    if($("#structureDisjointWith_" + i).length > 0 && $("#structureDisjointWith_" + i).val().length > 0)
    {
      var disjointWithObj = {
              };

      disjointWithObj[$('#structureDisjointWith_'
        + i).data("attr-uri")] = {
                uri: $('#structureDisjointWith_' + i).data("value-uri")
              };

      predicates.push(disjointWithObj);
    }
    else
    {
      break;
    }
  }

  // Get Equivalent class with relationship(s)
  for(i = 0; i < 256; i++)
  {
    if($("#structureEquivalentClass_" + i).length > 0 && $("#structureEquivalentClass_" + i).val().length > 0)
    {
      var equivalentClassObj = {
              };

      equivalentClassObj[$('#structureEquivalentClass_'
        + i).data("attr-uri")] = {
                uri: $('#structureEquivalentClass_' + i).data("value-uri")
              };

      predicates.push(equivalentClassObj);
    }
    else
    {
      break;
    }
  }

  // Get hasCharacteristic relationships
  for(i = 0; i < 512; i++)
  {
    if($("#characteristics_" + i).length > 0 && $("#characteristics_" + i).val().length > 0)
    {
      var hasCharacteristicClassObj = {
              };

      hasCharacteristicClassObj[$('#characteristics_'
        + i).data("attr-uri")] = {
                uri: $('#characteristics_' + i).data("value-uri")
              };

      predicates.push(hasCharacteristicClassObj);
    }
    else
    {
      break;
    }
  }

  // Get displayControl relationships
  for(i = 0; i < 256; i++)
  {
    if($("#displayControl_" + i).length > 0 && $("#displayControl_" + i).val().length > 0)
    {
      var displayControlClassObj = {
              };

      displayControlClassObj[$('#displayControl_'
        + i).data("attr-uri")] = {
                uri: $('#displayControl_' + i).data("value-uri")
              };

      predicates.push(displayControlClassObj);
    }
    else
    {
      break;
    }
  }

  // Get relationBrowserNodeType relationships
  for(i = 0; i < 256; i++)
  {
    if($("#relationBrowserNodeType_" + i).length > 0 && $("#relationBrowserNodeType_" + i).val().length > 0)
    {
      var relationBrowserNodeTypeClassObj = {
              };

      relationBrowserNodeTypeClassObj[$('#relationBrowserNodeType_'
        + i).data("attr-uri")] = {
                uri: $('#relationBrowserNodeType_' + i).data("value-uri")
              };

      predicates.push(relationBrowserNodeTypeClassObj);
    }
    else
    {
      break;
    }
  }


  // Get shortLabel relationships
  for(i = 0; i < 256; i++)
  {
    if($("#shortLabel_" + i).length > 0 && $("#shortLabel_" + i).val().length > 0)
    {
      var shortLabelObj = {
              };

      shortLabelObj[$('#shortLabel_' + i).data("attr-uri")] = $('#shortLabel_' + i).val();
      predicates.push(shortLabelObj);
    }
    else
    {
      break;
    }
  }

  // Get mapMarkerImageUrl relationships
  for(i = 0; i < 256; i++)
  {
    if($("#mapMarkerImageUrl_" + i).length > 0 && $("#mapMarkerImageUrl_" + i).val().length > 0)
    {
      var mapMarkerImageUrlObj = {
              };

      mapMarkerImageUrlObj[$('#mapMarkerImageUrl_' + i).data("attr-uri")] = $('#mapMarkerImageUrl_' + i).val();
      predicates.push(mapMarkerImageUrlObj);
    }
    else
    {
      break;
    }
  }

  // Get all other properties(s)
  for(i = 0; i < 256; i++)
  {
    for(ii = 0; ii < 256; ii++)
    {
      if($('#inputOthers_' + i + '_' + ii).length > 0 && $('#inputOthers_' + i + '_' + ii).val().length > 0)
      {
        var otherObj = {
                };

        if($('#inputOthers_' + i + '_' + ii).data("value-type") == "literal")
        {
          otherObj[$('#inputOthers_' + i + '_' + ii).data("attr-uri")] = $('#inputOthers_' + i + '_' + ii).val();
        }
        else if($('#inputOthers_' + i + '_' + ii).data("value-type") == "uri")
        {
          otherObj[$('#inputOthers_' + i + '_'
            + ii).data("attr-uri")] = {
                    uri: $('#inputOthers_' + i + '_' + ii).val()
                  };
        }

        predicates.push(otherObj);
      }
      else
      {
        break;
      }
    }

    if($('#inputOthers_' + (i + 1) + '_0').length <= 0)
    {
      break;
    }
  }

  rset = new Resultset({
            prefixes: currentEntityResultset.prefixes,
            resultset: {
                      subject: [
                        {
                                  uri: currentEntityResultset.subjects[0].uri,
                                  type: type,
                                  predicate: []
                                }
                      ]
                    }
          });

  rset.subjects[0].predicate = predicates;

  // Get Super Classes relationship(s)
  // Note: the superClassOf relationship are converted into subClassOf relationships by
  //       updating these sub-classes records with the subClassOf relationship to this
  //       super class.
  for(i = 0; i < 256; i++)
  {
    if($("#structureSuperClass_" + i).length > 0 && $("#structureSuperClass_" + i).val().length > 0)
    {
      var subClassResultset = $.ajax({
                type: "POST",
                url: network.replace(/\/+$/,"") + "/ontology/read/",
                dataType: "json",
                data: ({
                          "function": "getClass",
                          "reasoner": useReasoner,
                          "ontology": ontology,
                          parameters: "uri=" + $('#structureSuperClass_' + i).data("value-uri")
                        }),
                async: false
              }).responseText;

      var jsonResponseText = JSON.parse(subClassResultset);

      if('level' in jsonResponseText && 'debugInformation' in jsonResponseText)
      {
        $('#messagesContainer').fadeOut("fast", function()
        {
          $('#messagesContainer').empty();
        });

        var errorMsg = '[' + jsonResponseText.id + '] ' + jsonResponseText.name + ': ' + jsonResponseText.description;

        $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
        continue;
      }

      subClassResultset = new Resultset(jsonResponseText);

      // Remove the superClassOf relationship since we don't want to persist it into the ontologies store
      subClassResultset.subjects[0].removePredicateValues("http://umbel.org/umbel#superClassOf");

      // Make sure to remove the attribute/value that we are about to introduce.
      // That way we make sure not to duplicate the relationship.
      subClassResultset.subjects[0].removePredicateValue("http://www.w3.org/2000/01/rdf-schema#subClassOf",
        currentEntityResultset.subjects[0].uri);

      // Add that class as a sub-class-of the target class being manipulated
      subClassResultset.subjects[0].addAttributeValue("http://www.w3.org/2000/01/rdf-schema#subClassOf", {
                uri: currentEntityResultset.subjects[0].uri
              });

      rset.subjects.push(subClassResultset.subjects[0]);
    }
    else
    {
      break;
    }
  }

  // Do the same as above, but for super-class-of relationships that have been deleted for this target class.
  for(i = 0; i < removedSuperEntityOf.length; i++)
  {
    var subClassResultset = $.ajax({
              type: "POST",
              url: network.replace(/\/+$/,"") + "/ontology/read/",
              dataType: "json",
              data: ({
                        "function": "getClass",
                        "reasoner": useReasoner,
                        "ontology": ontology,
                        parameters: "uri=" + removedSuperEntityOf[i]
                      }),
              async: false
            }).responseText;

    var jsonResponseText = JSON.parse(subClassResultset);

    if('level' in jsonResponseText && 'debugInformation' in jsonResponseText)
    {
      $('#messagesContainer').fadeOut("fast", function()
      {
        $('#messagesContainer').empty();
      });

      var errorMsg = '[' + jsonResponseText.id + '] ' + jsonResponseText.name + ': ' + jsonResponseText.description;

      $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
      continue;
    }

    subClassResultset = new Resultset(jsonResponseText);

    // Remove the superClassOf relationship since we don't want to persist it into the ontologies store
    subClassResultset.subjects[0].removePredicateValues("http://umbel.org/umbel#superClassOf");

    // Remove the sub-class-of the target class being manipulated
    subClassResultset.subjects[0].removePredicateValue("http://www.w3.org/2000/01/rdf-schema#subClassOf",
      currentEntityResultset.subjects[0].uri);

    rset.subjects.push(subClassResultset.subjects[0]);
  }

  // Now add the classes or properties that could have been referenced that comes from external ontologies.
  // The goal here is to "import" them into the current ontology for future use
  for(i = 0; i < importedFromExternalOntology.length; i++)
  {
    var func = "";
    var typeParam = "";

    switch(importedFromExternalOntology[i].type)
    {
      case "class":
        func = "getClass";
        break;

      case "dataproperty":
      case "objectproperty":
      case "annotationproperty":
        func = "getProperty";
        break;

      case "namedindividual":
        func = "getNamedIndividual";
        break;
    }

    var entityResultset = $.ajax({
              type: "POST",
              url: network.replace(/\/+$/,"") + "/ontology/read/",
              dataType: "json",
              data: ({
                        "function": func,
                        "reasoner": useReasoner,
                        "ontology": importedFromExternalOntology[i].ontology,
                        parameters: "uri=" + importedFromExternalOntology[i].uri
                      }),
              async: false
            }).responseText;

    var jsonResponseText = JSON.parse(entityResultset);

    if('level' in jsonResponseText && 'debugInformation' in jsonResponseText)
    {
      $('#messagesContainer').fadeOut("fast", function()
      {
        $('#messagesContainer').empty();
      });

      var errorMsg = '[' + jsonResponseText.id + '] ' + jsonResponseText.name + ': ' + jsonResponseText.description;

      $('#messagesContainer').append('<div class="errorBox">' + errorMsg + '</div>').hide().fadeIn("fast");
      continue;
    }

    entityResultset = new Resultset(jsonResponseText);

    // Remove possible superClassOf, subClassOf, equivalentClass, disjointWith relationships
    // since we don't want to create new external classes on the fly.
    entityResultset.subjects[0].removePredicateValues("http://umbel.org/umbel#superClassOf");
    entityResultset.subjects[0].removePredicateValues("http://umbel.org/umbel#superPropertyOf");

    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#equivalentClass");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#disjointWith");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#equivalentObjectProperties");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#equivalentDataProperties");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#disjointObjectProperties");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#disjointDataProperties");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2002/07/owl#inverseOf");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2000/01/rdf-schema#domain");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2000/01/rdf-schema#range");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2000/01/rdf-schema#subClassOf");
    entityResultset.subjects[0].removePredicateValues("http://www.w3.org/2000/01/rdf-schema#subPropertyOf");

    rset.subjects.push(entityResultset.subjects[0]);
  }

  importedFromExternalOntology = [];

  // Possibly rename the node in the tree
  var contents = $.jstree._focused().get_selected().children("a").contents();

  if(contents.length > 0)
  {
    contents[contents.length - 1].nodeValue = rset.subjects[0].getPrefLabel();
  }

  $.ajax({
            type: "POST",
            url: structModulesBaseUrl.replace(/\/+$/,"") + "/ontology/proxy",
            dataType: "json",
            "data": {
                      ws: network.replace(/\/+$/,"") + "/ontology/update/",
                      method: "post",
                      accept: "application/json",
                      params: "ontology=" + escape(ontology) + "&function=createOrUpdateEntity&parameters="
                        + escape("document=" + escape(rset.saveN3())) + ";" + escape("advancedIndexation=true")
                    },
            "success": function(data)
            {
              $('#messagesContainer').append('<div class="successBox">Class successfully saved</div>').hide().fadeIn(
                "fast");

              $("#saveButtonAjax").hide();
              $("#saveButton").show();

              removedSuperEntityOf = [];

              if(reloadTree)
              {
                $("#classesTree").jstree("refresh", "httpwwww3org200207owlThing");
                reloadTree = false;
              }
            },
            "error": function(jqXHR, textStatus, error)
            {
              $('#messagesContainer').fadeOut("fast", function()
              {
                $('#messagesContainer').empty();

                $("#saveButtonAjax").hide();
                $("#saveButton").show();
              });

              if(jqXHR.status == 403)
              {
                $('#messagesContainer').append('<div class="errorBox">You need to have administrator permissions to modify an ontology.</div>').hide().fadeIn("fast");
              }
              else
              {
                $('#messagesContainer').append('<div class="errorBox">An error occured; please record this issue to the system administrator.</div>').hide().fadeIn("fast");
              }
            }
          })
}

function getClassesTreeOrderedPath(resultset, targetSuperClass)
{
  var path = [targetSuperClass];

  for(var i = 0; i < resultset.subjects.length; i++)
  {
    var superClasses = resultset.subjects[i].getPredicateValues("http://www.w3.org/2000/01/rdf-schema#subClassOf");

    for(var ii = 0; ii < superClasses.length; ii++)
    {
      if(superClasses[ii].uri == targetSuperClass)
      {
        var classes = getClassesTreeOrderedPath(resultset, resultset.subjects[i].uri);

        for(var iii = 0; iii < classes.length; iii++)
        {
          path.push(classes[iii]);
        }
      }
    }
  }

  return(path);
}

function submitViewSearchEnter(field, e)
{
  var keycode;

  if(window.event)
  {
    keycode = window.event.keyCode;
  }
  else if(e)
  {
    keycode = e.which;
  }
  else
  {
    return true;
  }

  if(keycode == 13)
  {
    viewSearch();

    return false;
  }
  else
  {
    return true;
  }
}

function viewSearch()
{
  switch(currentView)
  {
    case "classes":
      $("#classesTree").jstree("search",/*"structureSubClass",*/ $("#searchBox").val(), false);
      break;

    case "properties":
      $("#propertiesTree").jstree("search",/*"structureSubProperty",*/ $("#searchBox").val(), false);
      break;
  }
}

function addAttributeInputAutocomplete(containerID, attributePrefix, rowPrefix, attributeLabel, targetPredicate,
  forceReloadTree, searchFilterAttributes, searchFilterTypes, jsDrop)
{
  var attributes = currentEntityResultset.subjects[0].getPredicateValues(targetPredicate);

  var inputs = "";
  var hasValues = false;

  if(attributes.length > 0)
  {
    for(var i = 0; i <= attributes.length; i++)
    {
      if(i == attributes.length)
      {
        if(isAdmin)
        {
          inputs += '<input title="" id="' + attributePrefix + '_' + i + '" class="' + attributePrefix + 'InputText '
            + (jsDrop ? "jstree-drop" : "") + '" type="text" value="" />';
          inputs += '<img id="' + attributePrefix + '_' + i + '_img" class="' + attributePrefix
            + 'AddImg structureAddImg" src="' + structOntologyModuleFullPath
            + '/imgs/bullet_add.png" title="add" /><br />';
        }

        break;
      }

      var val = "";
      var title = "";

      if(typeof (attributes[i]) == 'object' && 'reify' in attributes[i])
      {
        val = attributes[i].reify[0].value;
      }
      else if(typeof (attributes[i]) == 'object' && 'uri' in attributes[i])
      {
        val = attributes[i].uri;
        title = attributes[i].uri;
      }
      else
      {
        val = attributes[i];
      }

      if(isAdmin)
      {
        inputs += '<input title="' + title + '" id="' + attributePrefix + '_' + i + '" class="'
          + attributePrefix + 'InputText ' + (jsDrop ? "jstree-drop" : "") + '" type="text" value="' + val + '" />';
        inputs += '<img id="' + attributePrefix + '_' + i + '_img" class="' + attributePrefix
          + 'AddImg structureAddImg" src="' + structOntologyModuleFullPath
          + '/imgs/bullet_delete.png" title="remove" /><br />';
      }
      else
      {
        if(jsDrop == true &&
           targetPredicate != "http://www.w3.org/2000/01/rdf-schema#subPropertyOf")
        {
          inputs += '<div id="' + attributePrefix + '_' + i + '" class="' + attributePrefix
                  + 'InputText"><a class="jsTreeLinksReadingMode" onclick="$(\'#classesTree\').jstree(\'search\', \''+val.replace(/^\s+/,"").replace(/\s+$/,"")+'\');">' + val + '</a></div>'                  
        }
        else
        {
          inputs += '<div id="' + attributePrefix + '_' + i + '" class="' + attributePrefix
                  + 'InputText">' + val + '</div>'
        }
                
        hasValues = true;
      } 
    }
  }
  else
  {
    if(isAdmin)
    {
      inputs += '<input id="' + attributePrefix + '_0" class="' + attributePrefix + 'InputText '
        + (jsDrop ? "jstree-drop" : "") + '" type="text" value="" />';
      inputs += '<img id="' + attributePrefix + '_0_img" class="' + attributePrefix + 'AddImg structureAddImg" src="'
        + structOntologyModuleFullPath + '/imgs/bullet_add.png" title="add" /><br />';
    }
  }
  
  // If it is not an admin, and that there is no value for this attribute, then we don't 
  // display anything for it.
  if(!isAdmin && !hasValues)
  {
    return;
  }    

  $("#" + containerID).append('<tr class="' + rowPrefix + 'Row"><td class="' + attributePrefix + 'Text" valign="top">'
    + attributeLabel + ':</td><td valign="top">' + inputs + '</td></tr>');

  // Set the data associated with all created elements.
  if(isAdmin)
  {
    for(var i = 0; i <= attributes.length; i++)
    {
      if(i == attributes.length)
      {
        $('#' + attributePrefix + '_' + i).data("value-uri", "");
        $('#' + attributePrefix + '_' + i).data("attr-prefix", attributePrefix);
        $('#' + attributePrefix + '_' + i).data("force-reload", forceReloadTree);
        $('#' + attributePrefix + '_' + i + '_img').click(function()
        {
          var id = $(this).attr("id").replace("_img", "");

          // Prevent re-adding of removed super classes
          if(removedSuperEntityOf.indexOf(id) != -1)
          {
            removedSuperEntityOf.slice(removedSuperEntityOf.indexOf(id), 1);
          }

          addInputAutocomplete($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"), true,
            $("#" + id).data("search-filter-attributes"), $("#" + id).data("search-filter-types"));

          reloadTree = $("#" + id).data("force-reload");
        });
      }
      else
      {
        $('#' + attributePrefix + '_' + i).data("value-uri", attributes[i].uri);
        $('#' + attributePrefix + '_' + i).data("attr-prefix", attributePrefix);
        $('#' + attributePrefix + '_' + i).data("force-reload", forceReloadTree);
        $('#' + attributePrefix + '_' + i + '_img').click(function()
        {
          var id = $(this).attr("id").replace("_img", "");

          if($("#" + id).data("attr-prefix").search("SuperClass") != -1)
          {
            removedSuperEntityOf.push($("#" + id).data("value-uri"));
          }

          removeInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));

          reloadTree = $("#" + id).data("force-reload");
        });
      }

      $('#' + attributePrefix + '_' + i).data("attr-uri", targetPredicate);
      $('#' + attributePrefix + '_' + i).data("value-type", "uri");
      $('#' + attributePrefix + '_' + i).data("element-id", i);
      $('#' + attributePrefix + '_' + i).data("search-filter-attributes", searchFilterAttributes);
      $('#' + attributePrefix + '_' + i).data("search-filter-types", searchFilterTypes);
      $('#' + attributePrefix + '_' + i).data("jsdrop", jsDrop);

      // Now add the "input-click" behaviors to the input controls
      $('#' + attributePrefix + '_' + i).focus(function()
      {
        $(this).data("inputText", $(this).val());
        $(this).val("");

        var ac = $(this).autocomplete({
                  serviceUrl: network.replace(/\/+$/,"") + "/search/",
                  minChars: 3,
                  //delimiter: /(,|;)\s*/, // regex or character
                  maxHeight: 400,
                  width: 300,
                  elementIndice: $(this).data("element-id"),
                  zIndex: 9999,
                  iconID: $(this).attr("id") + '_img',
                  onSelect: function(value, data, me)
                  {
                    me.data("value-uri", data.uri);
                    me.attr("title", data.uri);
                    me.data("inputText", value.substring(0, value.search("&nbsp;&nbsp;&nbsp;")));

                    if(data.ontology != ontology)
                    {
                      importedFromExternalOntology.push({
                                uri: data.uri,
                                type: data.type,
                                ontology: data.ontology
                              });
                    }

                    // Add a new input on selection of an item.

                    addInputAutocomplete(me.data("attr-prefix"), me.data("element-id"), me.data("jsdrop"),
                      me.data("search-filter-attributes"), me.data("search-filter-types"));

                    if(me.data("force-reload"))
                    {
                      reloadTree = true;
                    }
                  },
                  deferRequestBy: 300, //miliseconds
                  params: {
                            datasets: (extendedToAllOntologies ? "all" : ontology),
                            attributes: searchFilterAttributes,
                            page: 0,
                            items: 20,
                            include_aggregates: "false",
                            types: searchFilterTypes
                          },
                  noCache: false, //default is false, set to true to disable caching
                });

        searchAc.enable();

        $(this).focusout(function()
        {
          $(this).val($(this).data("inputText"));
          ac = null;
        })
      })
    }
  }
}

function toggleWaitingIcon(imgID)
{
  if($("#" + imgID).attr("src").search("ajax-loader-icon.gif") != -1)
  {
    $("#" + imgID).attr("src", $("#" + imgID).data("prevImg"))
  }
  else
  {
    $("#" + imgID).data("prevImg", $("#" + imgID).attr("src"));
    $("#" + imgID).attr("src", structOntologyModuleFullPath + '/imgs/ajax-loader-icon.gif');
  }
}

function removeInput(id, num)
{
  // Delete everything related to this entry
  $('#' + id + '_' + num).remove();                 // The input
  $('#' + id + '_' + num + '_img').next().remove(); // The last <br />
  $('#' + id + '_' + num + '_img').remove();        // The image button.

  // Now re-number all the inputs of the same groupe.
  for(i = (num + 1); i < 256; i++)
  {
    if($("#" + id + "_" + i).length > 0)
    {
      // Re-number all the related items to this entry
      $('#' + id + '_' + i).data("element-id", (i - 1));
      $('#' + id + '_' + i + '_img').attr("id", id + '_' + (i - 1) + '_img'); // The image button.
      $('#' + id + '_' + i).attr("id", id + '_' + (i - 1));                   // The input
    }
    else
    {
      break;
    }
  }
}

function addInputAutocomplete(id, num, jsDrop, searchFilterAttributes, searchFilterTypes)
{
  var input = "";

  input += '<input title="" id="' + id + '_' + (num + 1) + '" class="' + id + 'InputText '
    + (jsDrop ? "jstree-drop" : "") + '" type="text" value="" />';

  input += '<img id="' + id + '_' + (num + 1) + '_img" class="' + id + 'AddImg structureAddImg" src="'
    + structOntologyModuleFullPath + '/imgs/bullet_add.png" title="add" /><br />';

  $('#' + id + '_' + num).parent().append(input);

  $('#' + id + '_' + (num + 1)).data("value-uri", "");
  $('#' + id + '_' + (num + 1)).data("attr-uri", $('#' + id + '_' + num).data("attr-uri"));
  $('#' + id + '_' + (num + 1)).data("value-type", "uri");
  $('#' + id + '_' + (num + 1)).data("element-id", (num + 1));
  $('#' + id + '_' + (num + 1)).data("attr-prefix", id);
  $('#' + id + '_' + (num + 1)).data("search-filter-attributes", searchFilterAttributes);
  $('#' + id + '_' + (num + 1)).data("search-filter-types", searchFilterTypes);
  $('#' + id + '_' + (num + 1)).data("jsdrop", jsDrop);

  if(jsDrop == false)
  {
    $('#' + id + '_' + (num + 1) + '_img').click(function()
    {
      var id = $(this).attr("id").replace("_img", "");
      addInputAutocomplete($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"), false,
        $("#" + id).data("search-filter-attributes"), $("#" + id).data("search-filter-types"));

      // Prevent re-adding of removed super classes
      if(removedSuperEntityOf.indexOf(id) != -1)
      {
        removedSuperEntityOf.slice(removedSuperEntityOf.indexOf(id), 1);
      }

      reloadTree = $("#" + id).data("force-reload");
    });
  }
  else
  {
    $('#' + id + '_' + (num + 1) + '_img').click(function()
    {
      var id = $(this).attr("id").replace("_img", "");
      addInputAutocomplete($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"), true,
        $("#" + id).data("search-filter-attributes"), $("#" + id).data("search-filter-types"));

      // Prevent re-adding of removed super classes
      if(removedSuperEntityOf.indexOf(id) != -1)
      {
        removedSuperEntityOf.slice(removedSuperEntityOf.indexOf(id), 1);
      }

      reloadTree = $("#" + id).data("force-reload");
    });
  }

  $('#' + id + '_' + num + '_img').attr("src", structOntologyModuleFullPath + '/imgs/bullet_delete.png');
  $('#' + id + '_' + num + '_img').attr("title", 'remove');
  $('#' + id + '_' + num + '_img').unbind("click");

  $('#' + id + '_' + num + '_img').click(function()
  {
    var id = $(this).attr("id").replace("_img", "");
    removeInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));

    if($("#" + id).data("attr-prefix").search("SuperClass") != -1)
    {
      removedSuperEntityOf.push($("#" + id).data("value-uri"));
    }

    reloadTree = $("#" + id).data("force-reload");
  });

  $('#' + id + '_' + (num + 1)).focus(function()
  {
    $(this).data("inputText", $(this).val());
    $(this).val("");

    var ac = $(this).autocomplete({
              serviceUrl: network.replace(/\/+$/,"") + "/search/",
              minChars: 3,
              //delimiter: /(,|;)\s*/, // regex or character
              maxHeight: 400,
              width: 300,
              elementIndice: $(this).data("element-id"),
              zIndex: 9999,
              iconID: $(this).attr("id") + '_img',
              onSelect: function(value, data, me)
              {
                me.data("value-uri", data.uri);
                me.attr("title", data.uri);
                me.data("inputText", value);

                if(data.ontology != ontology)
                {
                  importedFromExternalOntology.push({
                            uri: data.uri,
                            type: data.type,
                            ontology: data.ontology
                          });
                }

                // Add a new input on selection of an item.

                addInputAutocomplete(me.data("attr-prefix"), me.data("element-id"), me.data("jsdrop"),
                  me.data("search-filter-attributes"), me.data("search-filter-types"));

                if(me.data("force-reload"))
                {
                  reloadTree = true;
                }
              },
              deferRequestBy: 300, //miliseconds
              params: {
                        datasets: (extendedToAllOntologies ? "all" : ontology),
                        attributes: $(this).data("search-filter-attributes"),
                        page: 0,
                        items: 20,
                        include_aggregates: "false",
                        types: $(this).data("search-filter-types")
                      },
              noCache: false, //default is false, set to true to disable caching
            });

    searchAc.enable();

    $(this).focusout(function()
    {
      $(this).val($(this).data("inputText"));
      ac = null;
    })
  })
}

function addAttributeInput(containerID, attributePrefix, rowPrefix, attributeLabel, targetPredicate)
{
  var attributes = currentEntityResultset.subjects[0].getPredicateValues(targetPredicate);

  var inputs = "";
  var hasValues = false;

  if(attributes.length > 0)
  {
    for(var i = 0; i <= attributes.length; i++)
    {
      if(i == attributes.length)
      {
        if(isAdmin)
        {
          inputs += '<input title="" id="' + attributePrefix + '_' + i + '" class="' + attributePrefix
            + 'InputText" type="text" value="" />';
          inputs += '<img id="' + attributePrefix + '_' + i + '_img" class="' + attributePrefix
            + 'AddImg structureAddImg" src="' + structOntologyModuleFullPath
            + '/imgs/bullet_add.png" title="add" /><br />';
        }

        break;
      }

      var val = "";

      if(typeof (attributes[i]) == 'object' && 'reify' in attributes[i])
      {
        val = attributes[i].reify[0].value;
      }
      else if(typeof (attributes[i]) == 'object' && 'uri' in attributes[i])
      {
        val = attributes[i].uri;
      }
      else
      {
        val = attributes[i];
      }

      if(isAdmin)
      {
        inputs += '<input title="' + attributes[i].uri + '" id="' + attributePrefix + '_' + i + '" class="'
          + attributePrefix + 'InputText" type="text" value="' + val + '" />';
        inputs += '<img id="' + attributePrefix + '_' + i + '_img" class="' + attributePrefix
          + 'AddImg structureAddImg" src="' + structOntologyModuleFullPath
          + '/imgs/bullet_delete.png" title="remove" /><br />';
      }
      else
      {
        inputs += '<div id="' + attributePrefix + '_' + i + '" class="' + attributePrefix
                + 'InputText">' + val + '</div>'
                
        hasValues = true;
      }        
    }
  }
  else
  {
    if(isAdmin)
    {
      inputs += '<input id="' + attributePrefix + '_0" class="' + attributePrefix + 'InputText" type="text" value="" />';
      inputs += '<img id="' + attributePrefix + '_0_img" class="' + attributePrefix + 'AddImg structureAddImg" src="'
        + structOntologyModuleFullPath + '/imgs/bullet_add.png" title="add" /><br />';
    }
  }

  // If it is not an admin, and that there is no value for this attribute, then we don't 
  // display anything for it.
  if(!isAdmin && !hasValues)
  {
    return;
  }  
  
  $("#" + containerID).append('<tr class="' + rowPrefix + 'Row"><td class="' + attributePrefix + 'Text" valign="top">'
    + attributeLabel + ':</td><td valign="top">' + inputs + '</td></tr>');

  // Set the data associated with all created elements.
  for(var i = 0; i <= attributes.length; i++)
  {
    if(i == attributes.length)
    {
      $('#' + attributePrefix + '_' + i).data("value-uri", "");
      $('#' + attributePrefix + '_' + i).data("attr-prefix", attributePrefix);
      $('#' + attributePrefix + '_' + i + '_img').click(function()
      {
        var id = $(this).attr("id").replace("_img", "");

        addInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));
      });
    }
    else
    {
      $('#' + attributePrefix + '_' + i).data("value-uri", attributes[i].uri);
      $('#' + attributePrefix + '_' + i).data("attr-prefix", attributePrefix);
      $('#' + attributePrefix + '_' + i + '_img').click(function()
      {
        var id = $(this).attr("id").replace("_img", "");

        removeInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));
      });
    }

    $('#' + attributePrefix + '_' + i).data("attr-uri", targetPredicate);
    $('#' + attributePrefix + '_' + i).data("value-type", "literal");
    $('#' + attributePrefix + '_' + i).data("element-id", i);
  }
}

function addInput(id, num)
{
  var input = "";

  input += '<input title="" id="' + id + '_' + (num + 1) + '" class="' + id + 'InputText" type="text" value="" />';

  input += '<img id="' + id + '_' + (num + 1) + '_img" class="' + id + 'AddImg structureAddImg" src="'
    + structOntologyModuleFullPath + '/imgs/bullet_add.png" title="add" /><br />';

  $('#' + id + '_' + num).parent().append(input);

  $('#' + id + '_' + (num + 1)).data("value-uri", "");
  $('#' + id + '_' + (num + 1)).data("attr-uri", $('#' + id + '_' + num).data("attr-uri"));
  $('#' + id + '_' + (num + 1)).data("value-type", "literal");
  $('#' + id + '_' + (num + 1)).data("element-id", (num + 1));
  $('#' + id + '_' + (num + 1)).data("attr-prefix", id);

  $('#' + id + '_' + (num + 1) + '_img').click(function()
  {
    var id = $(this).attr("id").replace("_img", "");
    addInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));
  });

  $('#' + id + '_' + num + '_img').attr("src", structOntologyModuleFullPath + '/imgs/bullet_delete.png');
  $('#' + id + '_' + num + '_img').attr("title", 'remove');
  $('#' + id + '_' + num + '_img').unbind("click");

  $('#' + id + '_' + num + '_img').click(function()
  {
    var id = $(this).attr("id").replace("_img", "");
    removeInput($("#" + id).data("attr-prefix"), $("#" + id).data("element-id"));
  });
}

function toggleClassesView()
{
  currentView = "classes";

  removedSuperEntityOf = [];

  //jQuery("#classesTree").jstree("select_node", "#"+lastSelectedClassNode);
  $("#" + lastSelectedClassNode).children("a").click();

  searchAc.options.params = {
            datasets: ontology,
            attributes: "http://purl.org/ontology/iron#prefLabel",
            page: 0,
            items: 20,
            include_aggregates: "false",
            types: "http://www.w3.org/2002/07/owl#Class"
          };

  $('#searchBox').val("");

  $("#classesTab").removeClass("classesTabUnselected");
  $("#classesTab").addClass("classesTabSelected");
  $("#propertiesTab").removeClass("propertiesTabSelected");
  $("#propertiesTab").addClass("propertiesTabUnselected");

  if(propertiesTreeCreated)
  {
    $("#propertiesTree").hide();
  }

  $("#classesTree").show();
}

function togglePropertiesView()
{
  currentView = "properties";

  removedSuperEntityOf = [];

  //jQuery("#propertiesTree").jstree("select_node", "#"+lastSelectedPropertyNode);
  $("#" + lastSelectedPropertyNode).children("a").click();

  searchAc.options.params = {
            datasets: ontology,
            attributes: "http://purl.org/ontology/iron#prefLabel",
            page: 0,
            items: 20,
            include_aggregates: "false",
            types:
              "http://www.w3.org/2002/07/owl#ObjectProperty;http://www.w3.org/2002/07/owl#DatatypeProperty;http://www.w3.org/2002/07/owl#AnnotationProperty"
          };

  $('#searchBox').val("");

  $("#classesTab").removeClass("classesTabSelected");
  $("#classesTab").addClass("classesTabUnselected");
  $("#propertiesTab").removeClass("propertiesTabUnselected");
  $("#propertiesTab").addClass("propertiesTabSelected");

  $("#classesTree").hide();

  if(propertiesTreeCreated)
  {
    $("#propertiesTree").show();
  }
  else
  {
    createPropertiesTree("http://www.w3.org/2002/07/owl#TopProperty");
  }
}

function toggleReasoner()
{
  if($("#reasonerButtonImg").attr("src").indexOf("cog_add") != -1)
  {
    // Enable the reasoner
    var imgUrl = $("#reasonerButtonImg").attr("src");
    $("#reasonerButtonImg").attr("src", imgUrl.replace("cog_add", "cog_delete"));

    var imgUrl = $("#reasonerBeaconImg").attr("src");
    $("#reasonerBeaconImg").attr("src", imgUrl.replace("bullet_red", "bullet_green"));

    $("#reasonerButtonImg").attr("title", "Disable Reasoner");
    $("#reasonerBeaconImg").attr("title", "Reasoner currently enabled");
    
    useReasoner = "true";
    
    // force tree refresh
    if($("#httpwwww3org200207owlThing").length > 0)
    {
      $("#classesTree").jstree("refresh", "httpwwww3org200207owlThing");
    }
    
    if($("#httpwwww3org200207owlTopProperty").length > 0)
    {
      $("#classesTree").jstree("refresh", "httpwwww3org200207owlTopProperty");
    }
    
  }
  else
  {
    // Disable the reasoner
    var imgUrl = $("#reasonerButtonImg").attr("src");
    $("#reasonerButtonImg").attr("src", imgUrl.replace("cog_delete", "cog_add"));
    
    var imgUrl = $("#reasonerBeaconImg").attr("src");
    $("#reasonerBeaconImg").attr("src", imgUrl.replace("bullet_green", "bullet_red"));    
    
    $("#reasonerButtonImg").attr("title", "Enable Reasoner");
    $("#reasonerBeaconImg").attr("title", "Reasoner currently disabled");
    
    useReasoner = "false";
    
    // force tree refresh
    if($("#httpwwww3org200207owlThing").length > 0)
    {
      $("#classesTree").jstree("refresh", "httpwwww3org200207owlThing");
    }
    
    if($("#httpwwww3org200207owlTopProperty").length > 0)
    {
      $("#classesTree").jstree("refresh", "httpwwww3org200207owlTopProperty");
    }    
  }
}